source: common/func_validate_configs.sh@ 4612459

experimental
Last change on this file since 4612459 was 4612459, checked in by Manuel Canales Esparcia <manuel@…>, 18 years ago

Adding farce to config options.

  • Property mode set to 100644
File size: 9.8 KB
RevLine 
[c0aeabe]1# $Id$
[3bbf6d5]2
[3c61617]3validate_target() {
4
5 local -r ERROR_MSG_pt1='The variable \"${L_arrow}TARGET${R_arrow}\" value ${L_arrow}${BOLD}${TARGET}${R_arrow} is invalid for the ${L_arrow}${BOLD}${ARCH}${R_arrow} architecture'
6 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
7
8 local -r PARAM_VALS='TARGET: ${L_arrow}${BOLD}${TARGET}${OFF}${R_arrow}'
9 local -r PARAM_VALS2='TARGET32: ${L_arrow}${BOLD}${TARGET32}${OFF}${R_arrow}'
10
11 write_error_and_die() {
12 echo -e "\n${DD_BORDER}"
13 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
14 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
15 echo -e "${DD_BORDER}\n"
16 exit 1
17 }
18
19 if [[ ! "${TARGET32}" = "" ]]; then
[3051f95]20 echo -e "`eval echo $PARAM_VALS2`"
[3c61617]21 fi
[3051f95]22 echo -e "`eval echo $PARAM_VALS`"
[3c61617]23
24 case "${ARCH}" in
[3e0594f]25 "x86") [[ "${TARGET}" = "i486-pc-linux-gnu" ]] && return
26 [[ "${TARGET}" = "i586-pc-linux-gnu" ]] && return
27 [[ "${TARGET}" = "i686-pc-linux-gnu" ]] && return
[3c61617]28 ;;
[3e0594f]29 "ppc") [[ "${TARGET}" = "powerpc-unknown-linux-gnu" ]] && return
[3c61617]30 ;;
[3e0594f]31 "mips") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
32 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] && return
[3c61617]33 ;;
[3e0594f]34 "sparc") [[ "${TARGET}" = "sparcv9-unknown-linux-gnu" ]] && return
[3c61617]35 ;;
[3e0594f]36 "sparcv8") [[ "${TARGET}" = "sparc-unknown-linux-gnu" ]] && return
[3c61617]37 ;;
[3e0594f]38 "x86_64-64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] && return
[3c61617]39 ;;
40 "mips64-64") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
41 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] && return
42 ;;
43 "sparc64-64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] && return
44 ;;
45 "alpha") [[ "${TARGET}" = "alpha-unknown-linux-gnu" ]] && return
46 ;;
47 "x86_64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] &&
48 [[ "${TARGET32}" = "i686-pc-linux-gnu" ]] && return
49 ;;
50 "mips64") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] &&
51 [[ "${TARGET32}" = "mipsel-unknown-linux-gnu" ]] && return
[ffd482f]52
[3c61617]53 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] &&
54 [[ "${TARGET32}" = "mips-unknown-linux-gnu" ]] && return
55 ;;
[3e0594f]56 "sparc64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] &&
57 [[ "${TARGET32}" = "sparcv9-unknown-linux-gnu" ]] && return
[3c61617]58 ;;
[3e0594f]59 "ppc64") [[ "${TARGET}" = "powerpc64-unknown-linux-gnu" ]] &&
60 [[ "${TARGET32}" = "powerpc-unknown-linux-gnu" ]] && return
[3c61617]61 ;;
62 *) write_error_and_die
[ffd482f]63 ;;
[3c61617]64 esac
[3e0594f]65
66 # If you end up here then there was an error SO...
67 write_error_and_die
[3c61617]68}
69
70
[22670f4]71#----------------------------#
72validate_config() { # Are the config values sane (within reason)
73#----------------------------#
74: <<inline_doc
[3bbf6d5]75 Validates the configuration parameters. The global var PROGNAME selects the
[22670f4]76 parameter list.
[3bbf6d5]77
[3051f95]78 input vars: none
[22670f4]79 externals: color constants
80 PROGNAME (lfs,clfs,hlfs,blfs)
81 modifies: none
82 returns: nothing
[4612459]83 on error: write text to console and dies
[22670f4]84 on success: write text to console and returns
85inline_doc
86
[51a0bb1]87 # First internal variables, then the ones that change the book's flavour, and lastly system configuration variables
[2f0a537]88 local -r blfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG DEPEND TEST"
[4612459]89 local -r hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE MODEL GRSECURITY_HOST TEST RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG KEYMAP PAGE TIMEZONE LANG LC_ALL"
90 local -r clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE METHOD ARCH TARGET TEST RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB BOOT_CONFIG CONFIG KEYMAP VIMLANG PAGE TIMEZONE LANG"
91 local -r lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE HPKG RUNMAKE TEST RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG VIMLANG PAGE TIMEZONE LANG"
[22670f4]92
[3c61617]93 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
94 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
[22670f4]95 local -r PARAM_VALS='${config_param}: ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
96
97 local PARAM_LIST=
98
99 local config_param
100 local validation_str
[ffd482f]101
[22670f4]102 write_error_and_die() {
103 echo -e "\n${DD_BORDER}"
[3c61617]104 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
105 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
[22670f4]106 echo -e "${DD_BORDER}\n"
107 exit 1
108 }
109
[cc82e37]110 validate_str() {
111 # This is the 'regexp' test available in bash-3.0..
112 # using it as a poor man's test for substring
[3051f95]113 echo -e "`eval echo $PARAM_VALS`"
[cc82e37]114 if [[ ! "${validation_str}" =~ "x${!config_param}x" ]] ; then
115 # parameter value entered is no good
116 write_error_and_die
117 fi
118 }
[ffd482f]119
[22670f4]120 set +e
[cc82e37]121 for PARAM_GROUP in ${PROGNAME}_PARAM_LIST; do
[22670f4]122 for config_param in ${!PARAM_GROUP}; do
123 # This is a tricky little piece of code.. executes a cmd string.
124 case $config_param in
125 BUILDDIR) # We cannot have an <empty> or </> root mount point
[3051f95]126 echo -e "`eval echo $PARAM_VALS`"
[22670f4]127 if [[ "xx x/x" =~ "x${!config_param}x" ]]; then
128 write_error_and_die
129 fi
130 continue ;;
[2f0a537]131 TIMEZONE) continue;;
132 MKFILE) continue;;
133 HPKG) validation_str="x0x x1x"; validate_str; continue ;;
134 RUNMAKE) validation_str="x0x x1x"; validate_str; continue ;;
135 RUN_ICA) validation_str="x0x x1x"; validate_str; continue ;;
[4612459]136 RUN_FARCE) validation_str="x0x x1x"; validate_str; continue ;;
[2f0a537]137 ITERATIONS) validation_str="x2x x3x x4x x5x"; validate_str; continue ;;
138 TEST) validation_str="x0x x1x x2x x3x"; validate_str; continue ;;
139 STRIP) validation_str="x0x x1x"; validate_str; continue ;;
140 VIMLANG) validation_str="x0x x1x"; validate_str; continue ;;
141 DEPEND) validation_str="x0x x1x x2x"; validate_str; continue ;;
142 MODEL) validation_str="xglibcx xuclibcx"; validate_str; continue ;;
143 PAGE) validation_str="xletterx xA4x"; validate_str; continue ;;
144 GRSECURITY_HOST) validation_str="x0x x1x"; validate_str; continue ;;
145 METHOD) validation_str="xchrootx xbootx"; validate_str; continue ;;
146 ARCH) validation_str="xx86x xx86_64x xx86_64-64x xsparcx xsparcv8x xsparc64x xsparc64-64x xmipsx xmips64x xmips64-64x xppcx xppc64x xalphax"; validate_str; continue ;;
147 TARGET) validate_target; continue ;;
[22670f4]148 esac
149
[fdd1aa3e]150
[cc82e37]151 if [[ "${config_param}" = "LC_ALL" ]]; then
[3051f95]152 echo "`eval echo $PARAM_VALS`"
[cc82e37]153 [[ -z "${!config_param}" ]] && continue
154 # See it the locale values exist on this machine
155 if [[ "`locale -a | grep -c ${!config_param}`" > 0 ]]; then
156 continue
157 else # If you make it this far then there is a problem
158 write_error_and_die
159 fi
160 fi
[dbf2c71]161
[cc82e37]162 if [[ "${config_param}" = "LANG" ]]; then
[3051f95]163 echo "`eval echo $PARAM_VALS`"
[cc82e37]164 [[ -z "${!config_param}" ]] && continue
[dbf2c71]165 # See it the locale values exist on this machine
[cc82e37]166 if [[ "`locale -a | grep -c ${!config_param}`" > 0 ]]; then
167 continue
168 else # If you make it this far then there is a problem
169 write_error_and_die
170 fi
[ffd482f]171 fi
[cc82e37]172
173
174 if [[ "${config_param}" = "KEYMAP" ]]; then
[3051f95]175 echo "`eval echo $PARAM_VALS`"
[cc82e37]176 [[ "${!config_param}" = "none" ]] && continue
[ffd482f]177 if [[ -e "/usr/share/kbd/keymaps/${!config_param}" ]] &&
[cc82e37]178 [[ -s "/usr/share/kbd/keymaps/${!config_param}" ]]; then
179 continue
180 else
181 write_error_and_die
182 fi
183 fi
184
185 if [[ "${config_param}" = "SRC_ARCHIVE" ]]; then
[3051f95]186 echo -n "`eval echo $PARAM_VALS`"
[cc82e37]187 if [ ! -z ${SRC_ARCHIVE} ]; then
188 if [ ! -d ${SRC_ARCHIVE} ]; then
189 echo " -- is NOT a directory"
[4612459]190 write_error_and_die
[cc82e37]191 fi
192 if [ ! -w ${SRC_ARCHIVE} ]; then
193 echo -n "${nl_} [${BOLD}${YELLOW}WARN$OFF] You do not have <write> access to this directory, ${nl_}${tab_}downloaded files can not be saved in this archive"
194 fi
[dbf2c71]195 fi
[cc82e37]196 echo
197 continue
[dbf2c71]198 fi
[3bbf6d5]199
[cc82e37]200 if [[ "${config_param}" = "FSTAB" ]]; then
[3051f95]201 echo "`eval echo $PARAM_VALS`"
[cc82e37]202 [[ -z "${!config_param}" ]] && continue
203 if [[ -e "${!config_param}" ]] &&
204 [[ -s "${!config_param}" ]]; then
205 continue
206 else
207 write_error_and_die
208 fi
209 fi
[22670f4]210
[cc82e37]211 if [[ "${config_param}" = "BOOK" ]]; then
[3051f95]212 echo "`eval echo $PARAM_VALS`"
[22670f4]213 [[ ! "${WC}" = 1 ]] && continue
[cc82e37]214 [[ -z "${!config_param}" ]] && continue
[ffd482f]215 if [[ -e "${!config_param}" ]] &&
216 [[ -s "${!config_param}" ]]; then
[cc82e37]217 continue
218 else
219 write_error_and_die
220 fi
[22670f4]221 fi
[cc82e37]222
223 if [[ "${config_param}" = "CONFIG" ]]; then
[3051f95]224 echo "`eval echo $PARAM_VALS`"
[cc82e37]225 [[ -z "${!config_param}" ]] && continue
[ffd482f]226 if [[ -e "${!config_param}" ]] &&
[cc82e37]227 [[ -s "${!config_param}" ]]; then
228 continue
229 else
230 write_error_and_die
231 fi
[6eef5ef]232 fi
[cc82e37]233
234 if [[ "${config_param}" = "BOOT_CONFIG" ]]; then
235 if [[ "${METHOD}" = "boot" ]]; then
[3051f95]236 echo "`eval echo $PARAM_VALS`"
[cc82e37]237 # There must be a config file when the build method is 'boot'
238 [[ -e "${!config_param}" ]] && [[ -s "${!config_param}" ]] && continue
239 # If you make it this far then there is a problem
240 write_error_and_die
241 fi
242 fi
[51a0bb1]243 done
[22670f4]244 done
[6eef5ef]245
[22670f4]246 set -e
[cc82e37]247 echo "$tab_***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***"
[22670f4]248}
Note: See TracBrowser for help on using the repository browser.